#!/usr/bin/perl
#!/usr/local/bin/perl
#!c:/perl/bin/perl.exe
#!c:/program files/perl/perl.exe

################################################################################
# @\ANZXCGIiANZXO MOpj
# Ver 1.3
# Copyright(C) futomi 2000
# http://www.futomi.com/
###############################################################################
require './accconfig.pl';

use CGI;
$co = new CGI;
$| = 1;

# Access Log Lotation
if($LOTATION) {
	($sec, $min, $hour, $mday, $mon, $year) = localtime(time);
	$year += 1900;
	$mon += 1;
	$mon = '0'. $mon if($mon < 10);
	$mday = '0'. $mday if($mday < 10);
	$date = "$year$mon$mday";
	$log_size = -s "$LOG";
	if($log_size > $LOTATION_SIZE) {
		if($LOTATION_SAVE) {
			rename("$LOG", "$LOG\.$date") || die 'Failed to lotate access log';
		} else {
			unlink("$LOG") || die 'Failed to lotate access log';
		}
	}
}


# Remote host
if($ENV{'REMOTE_HOST'} eq '') {
	$remote_host = gethostbyaddr(pack('C4',split(/\./,$ENV{'REMOTE_ADDR'})),2) || $ENV{'REMOTE_ADDR'};
} else {
	$remote_host = $ENV{'REMOTE_HOST'};
}

# ident
$ident  = '-';

# Remote user
if($ENV{'REMOTE_USER'} eq '') {
	$remote_user = '-';
} else {
	$remote_user = $ENV{'REMOTE_USER'};
}

# The date and time of the request
$date = &TimeStamp(time);

# First line of request

$request = $co->param('url');
unless($request) {
	if($ENV{'HTTP_REFERER'} eq '') {
		$request = '-';
	} else {
		$request = $ENV{'HTTP_REFERER'};
	}
}
if($request) {
	$_ = $request;
	m|http://[^/]+/(.*)|;
	$request = '/'.$1;
}
$request = "$ENV{'REQUEST_METHOD'} $request $ENV{'SERVER_PROTOCOL'}";


# Status
$status = '200';

# The number of bytes in the object returned to the client, not including any headers. 
$byete_sent = '-';

# HTTP_REFERER
$referrer = $co->param('referrer');
if($referrer =~ /\?/) {
	($url1, $url2) = split(/\?/, $referrer);
	$encode_url2 = &URL_encode($url2);
	$referrer = $url1 . '?' . $encode_url2;
}
if($referrer eq '') {
	$referrer = '-';
}

# O̓eϐu$logfilevɊi[
$logfile = "$remote_host $ident $remote_user $date \"$request\" $status $byete_sent \"$referrer\" \"$ENV{'HTTP_USER_AGENT'}\"";
if($ENV{'HTTP_ACCEPT_LANGUAGE'} eq '') {
	$logfile .= " \"-\"";
} else {
	$logfile .= " \"$ENV{'HTTP_ACCEPT_LANGUAGE'}\"";
}
$ScreenWidth = $co->param('width');
$ScreenHeight = $co->param('height');
$ColorDepth = $co->param('color');
if($ScreenWidth && $ScreenHeight && $ColorDepth) {
	$logfile .= " \"$ScreenWidth $ScreenHeight $ColorDepth\"";
} else {
	$logfile .= ' "-"';
}

# Lock Log file
open(LOGFILE, ">>$LOG");
unless(&Lock(LOGFILE)) {
	exit;
}

# Loging
print LOGFILE "$logfile\n";

# Unlock Log file
&Unlock(LOGFILE);

# Close log file
close(LOGFILE);


# Print Image to the Client

if($ENV{SCRIPT_FILENAME } =~ /png$/) {
	open(IMAGE, "<$JLOGO");
	$logo_size = -s "$JLOGO";
	read IMAGE, $data, $logo_size;
	close IMAGE;
	print $co->header(-type=>'image/png'), $data;
} else {
	open(IMAGE, "<$LOGO");
	$logo_size = -s "$LOGO";
	read IMAGE, $data, $logo_size;
	close IMAGE;
	print $co->header(-type=>'image/gif'), $data;
}


sub URL_encode {
	my($str) = @_;
	$str =~ s/([^\w\=\& ])/'%' . unpack("H2", $1)/eg;
	$str =~ tr/ /+/;
	return $str;
}


sub TimeStamp {
	my($time) = @_;
	my($sec, $min, $hour, $mday, $mon, $year) = localtime($time + $TIMEDIFF*60*60);
	$year += 1900;
	$mon += 1;

	my(%month) = (
		1	=>	'Jan',
		2	=>	'Feb',
		3	=>	'Mar',
		4	=>	'Apr',
		5	=>	'May',
		6	=>	'Jun',
		7	=>	'Jul',
		8	=>	'Aug',
		9	=>	'Sep',
		10	=>	'Oct',
		11	=>	'Nov',
		12	=>	'Dec'
	);
	$mon = $month{$mon};

	$mday = "0$mday" if($mday < 10);
	$hour = "0$hour" if($hour < 10);
	$min = "0$min" if($min < 10);
	$sec = "0$sec" if($sec < 10);
	my($stamp) = "[$mday/$mon/$year:$hour:$min:$sec +0900]";
	return $stamp;
}


sub Lock {
	local(*FILE) = @_;
	my($retry) = 3;
	my($lockresult);
	while($retry-- > 0) {
		$lockresult = eval("flock(FILE, 2)");
		if($@) {
			$retry = -1;
			last;
		}
		if(!$lockresult) {
			sleep(2);
		} else {
			last;
		}
	}
	if($retry > 0) {
		return 1;
	} else {
		return 0;
	}
}

sub Unlock {
	local(*FILE) = @_;
	flock(FILE, 8);
}



